<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/textwrap-0.15.0/src/wrap_algorithms.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>wrap_algorithms.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../textwrap/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../textwrap/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../textwrap/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
</pre><pre class="rust"><code><span class="doccomment">//! Word wrapping algorithms.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! After a text has been broken into words (or [`Fragment`]s), one</span>
<span class="doccomment">//! now has to decide how to break the fragments into lines. The</span>
<span class="doccomment">//! simplest algorithm for this is implemented by [`wrap_first_fit`]:</span>
<span class="doccomment">//! it uses no look-ahead and simply adds fragments to the line as</span>
<span class="doccomment">//! long as they fit. However, this can lead to poor line breaks if a</span>
<span class="doccomment">//! large fragment almost-but-not-quite fits on a line. When that</span>
<span class="doccomment">//! happens, the fragment is moved to the next line and it will leave</span>
<span class="doccomment">//! behind a large gap. A more advanced algorithm, implemented by</span>
<span class="doccomment">//! [`wrap_optimal_fit`], will take this into account. The optimal-fit</span>
<span class="doccomment">//! algorithm considers all possible line breaks and will attempt to</span>
<span class="doccomment">//! minimize the gaps left behind by overly short lines.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! While both algorithms run in linear time, the first-fit algorithm</span>
<span class="doccomment">//! is about 4 times faster than the optimal-fit algorithm.</span>

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;smawk&quot;</span>)]</span>
<span class="kw">mod</span> <span class="ident">optimal_fit</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;smawk&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">optimal_fit</span>::{<span class="ident">wrap_optimal_fit</span>, <span class="ident">OverflowError</span>, <span class="ident">Penalties</span>};

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::core</span>::{<span class="ident">Fragment</span>, <span class="ident">Word</span>};

<span class="doccomment">/// Describes how to wrap words into lines.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The simplest approach is to wrap words one word at a time and</span>
<span class="doccomment">/// accept the first way of wrapping which fit</span>
<span class="doccomment">/// ([`WrapAlgorithm::FirstFit`]). If the `smawk` Cargo feature is</span>
<span class="doccomment">/// enabled, a more complex algorithm is available which will look at</span>
<span class="doccomment">/// an entire paragraph at a time in order to find optimal line breaks</span>
<span class="doccomment">/// ([`WrapAlgorithm::OptimalFit`]).</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Copy</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">WrapAlgorithm</span> {
    <span class="doccomment">/// Wrap words using a fast and simple algorithm.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This algorithm uses no look-ahead when finding line breaks.</span>
    <span class="doccomment">/// Implemented by [`wrap_first_fit`], please see that function for</span>
    <span class="doccomment">/// details and examples.</span>
    <span class="ident">FirstFit</span>,

    <span class="doccomment">/// Wrap words using an advanced algorithm with look-ahead.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This wrapping algorithm considers the entire paragraph to find</span>
    <span class="doccomment">/// optimal line breaks. When wrapping text, &quot;penalties&quot; are</span>
    <span class="doccomment">/// assigned to line breaks based on the gaps left at the end of</span>
    <span class="doccomment">/// lines. See [`Penalties`] for details.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The underlying wrapping algorithm is implemented by</span>
    <span class="doccomment">/// [`wrap_optimal_fit`], please see that function for examples.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// **Note:** Only available when the `smawk` Cargo feature is</span>
    <span class="doccomment">/// enabled.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;smawk&quot;</span>)]</span>
    <span class="ident">OptimalFit</span>(<span class="ident">Penalties</span>),

    <span class="doccomment">/// Custom wrapping function.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Use this if you want to implement your own wrapping algorithm.</span>
    <span class="doccomment">/// The function can freely decide how to turn a slice of</span>
    <span class="doccomment">/// [`Word`]s into lines.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Example</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// use textwrap::core::Word;</span>
    <span class="doccomment">/// use textwrap::{wrap, Options, WrapAlgorithm};</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// fn stair&lt;&#39;a, &#39;b&gt;(words: &amp;&#39;b [Word&lt;&#39;a&gt;], _: &amp;&#39;b [usize]) -&gt; Vec&lt;&amp;&#39;b [Word&lt;&#39;a&gt;]&gt; {</span>
    <span class="doccomment">///     let mut lines = Vec::new();</span>
    <span class="doccomment">///     let mut step = 1;</span>
    <span class="doccomment">///     let mut start_idx = 0;</span>
    <span class="doccomment">///     while start_idx + step &lt;= words.len() {</span>
    <span class="doccomment">///       lines.push(&amp;words[start_idx .. start_idx+step]);</span>
    <span class="doccomment">///       start_idx += step;</span>
    <span class="doccomment">///       step += 1;</span>
    <span class="doccomment">///     }</span>
    <span class="doccomment">///     lines</span>
    <span class="doccomment">/// }</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// let options = Options::new(10).wrap_algorithm(WrapAlgorithm::Custom(stair));</span>
    <span class="doccomment">/// assert_eq!(wrap(&quot;First, second, third, fourth, fifth, sixth&quot;, options),</span>
    <span class="doccomment">///            vec![&quot;First,&quot;,</span>
    <span class="doccomment">///                 &quot;second, third,&quot;,</span>
    <span class="doccomment">///                 &quot;fourth, fifth, sixth&quot;]);</span>
    <span class="doccomment">/// ```</span>
    <span class="ident">Custom</span>(<span class="kw">for</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="lifetime">&#39;b</span><span class="op">&gt;</span> <span class="kw">fn</span>(<span class="ident">words</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;b</span> [<span class="ident">Word</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>], <span class="ident">line_widths</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;b</span> [<span class="ident">usize</span>]) -&gt; <span class="ident">Vec</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;b</span> [<span class="ident">Word</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>]<span class="op">&gt;</span>),
}

<span class="kw">impl</span> <span class="ident">std::fmt::Debug</span> <span class="kw">for</span> <span class="ident">WrapAlgorithm</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">std::fmt::Formatter</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>) -&gt; <span class="ident">std::fmt::Result</span> {
        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">WrapAlgorithm::FirstFit</span> =&gt; <span class="ident">f</span>.<span class="ident">write_str</span>(<span class="string">&quot;FirstFit&quot;</span>),
            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;smawk&quot;</span>)]</span>
            <span class="ident">WrapAlgorithm::OptimalFit</span>(<span class="ident">penalties</span>) =&gt; <span class="macro">write!</span>(<span class="ident">f</span>, <span class="string">&quot;OptimalFit({:?})&quot;</span>, <span class="ident">penalties</span>),
            <span class="ident">WrapAlgorithm::Custom</span>(<span class="kw">_</span>) =&gt; <span class="ident">f</span>.<span class="ident">write_str</span>(<span class="string">&quot;Custom(...)&quot;</span>),
        }
    }
}

<span class="kw">impl</span> <span class="ident">WrapAlgorithm</span> {
    <span class="doccomment">/// Create new wrap algorithm.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The best wrapping algorithm is used by default, i.e.,</span>
    <span class="doccomment">/// [`WrapAlgorithm::OptimalFit`] if available, otherwise</span>
    <span class="doccomment">/// [`WrapAlgorithm::FirstFit`].</span>
    <span class="kw">pub</span> <span class="kw">const</span> <span class="kw">fn</span> <span class="ident">new</span>() -&gt; <span class="self">Self</span> {
        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;smawk&quot;</span>))]</span>
        {
            <span class="ident">WrapAlgorithm::FirstFit</span>
        }

        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;smawk&quot;</span>)]</span>
        {
            <span class="ident">WrapAlgorithm::new_optimal_fit</span>()
        }
    }

    <span class="doccomment">/// New [`WrapAlgorithm::OptimalFit`] with default penalties. This</span>
    <span class="doccomment">/// works well for monospace text.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// **Note:** Only available when the `smawk` Cargo feature is</span>
    <span class="doccomment">/// enabled.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;smawk&quot;</span>)]</span>
    <span class="kw">pub</span> <span class="kw">const</span> <span class="kw">fn</span> <span class="ident">new_optimal_fit</span>() -&gt; <span class="self">Self</span> {
        <span class="ident">WrapAlgorithm::OptimalFit</span>(<span class="ident">Penalties::new</span>())
    }

    <span class="doccomment">/// Wrap words according to line widths.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The `line_widths` slice gives the target line width for each</span>
    <span class="doccomment">/// line (the last slice element is repeated as necessary). This</span>
    <span class="doccomment">/// can be used to implement hanging indentation.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">wrap</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="lifetime">&#39;b</span><span class="op">&gt;</span>(
        <span class="kw-2">&amp;</span><span class="self">self</span>,
        <span class="ident">words</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;b</span> [<span class="ident">Word</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>],
        <span class="ident">line_widths</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;b</span> [<span class="ident">usize</span>],
    ) -&gt; <span class="ident">Vec</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;b</span> [<span class="ident">Word</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>]<span class="op">&gt;</span> {
        <span class="comment">// Every integer up to 2u64.pow(f64::MANTISSA_DIGITS) = 2**53</span>
        <span class="comment">// = 9_007_199_254_740_992 can be represented without loss by</span>
        <span class="comment">// a f64. Larger line widths will be rounded to the nearest</span>
        <span class="comment">// representable number.</span>
        <span class="kw">let</span> <span class="ident">f64_line_widths</span> <span class="op">=</span> <span class="ident">line_widths</span>.<span class="ident">iter</span>().<span class="ident">map</span>(<span class="op">|</span><span class="ident">w</span><span class="op">|</span> <span class="kw-2">*</span><span class="ident">w</span> <span class="kw">as</span> <span class="ident">f64</span>).<span class="ident">collect</span>::<span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="kw">_</span><span class="op">&gt;</span><span class="op">&gt;</span>();

        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">WrapAlgorithm::FirstFit</span> =&gt; <span class="ident">wrap_first_fit</span>(<span class="ident">words</span>, <span class="kw-2">&amp;</span><span class="ident">f64_line_widths</span>),

            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;smawk&quot;</span>)]</span>
            <span class="ident">WrapAlgorithm::OptimalFit</span>(<span class="ident">penalties</span>) =&gt; {
                <span class="comment">// The computation cannnot overflow when the line</span>
                <span class="comment">// widths are restricted to usize.</span>
                <span class="ident">wrap_optimal_fit</span>(<span class="ident">words</span>, <span class="kw-2">&amp;</span><span class="ident">f64_line_widths</span>, <span class="ident">penalties</span>).<span class="ident">unwrap</span>()
            }

            <span class="ident">WrapAlgorithm::Custom</span>(<span class="ident">func</span>) =&gt; <span class="ident">func</span>(<span class="ident">words</span>, <span class="ident">line_widths</span>),
        }
    }
}

<span class="kw">impl</span> <span class="ident">Default</span> <span class="kw">for</span> <span class="ident">WrapAlgorithm</span> {
    <span class="kw">fn</span> <span class="ident">default</span>() -&gt; <span class="self">Self</span> {
        <span class="ident">WrapAlgorithm::new</span>()
    }
}

<span class="doccomment">/// Wrap abstract fragments into lines with a first-fit algorithm.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The `line_widths` slice gives the target line width for each line</span>
<span class="doccomment">/// (the last slice element is repeated as necessary). This can be</span>
<span class="doccomment">/// used to implement hanging indentation.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The fragments must already have been split into the desired</span>
<span class="doccomment">/// widths, this function will not (and cannot) attempt to split them</span>
<span class="doccomment">/// further when arranging them into lines.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # First-Fit Algorithm</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This implements a simple “greedy” algorithm: accumulate fragments</span>
<span class="doccomment">/// one by one and when a fragment no longer fits, start a new line.</span>
<span class="doccomment">/// There is no look-ahead, we simply take first fit of the fragments</span>
<span class="doccomment">/// we find.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// While fast and predictable, this algorithm can produce poor line</span>
<span class="doccomment">/// breaks when a long fragment is moved to a new line, leaving behind</span>
<span class="doccomment">/// a large gap:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use textwrap::core::Word;</span>
<span class="doccomment">/// use textwrap::wrap_algorithms::wrap_first_fit;</span>
<span class="doccomment">/// use textwrap::WordSeparator;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// // Helper to convert wrapped lines to a Vec&lt;String&gt;.</span>
<span class="doccomment">/// fn lines_to_strings(lines: Vec&lt;&amp;[Word&lt;&#39;_&gt;]&gt;) -&gt; Vec&lt;String&gt; {</span>
<span class="doccomment">///     lines.iter().map(|line| {</span>
<span class="doccomment">///         line.iter().map(|word| &amp;**word).collect::&lt;Vec&lt;_&gt;&gt;().join(&quot; &quot;)</span>
<span class="doccomment">///     }).collect::&lt;Vec&lt;_&gt;&gt;()</span>
<span class="doccomment">/// }</span>
<span class="doccomment">///</span>
<span class="doccomment">/// let text = &quot;These few words will unfortunately not wrap nicely.&quot;;</span>
<span class="doccomment">/// let words = WordSeparator::AsciiSpace.find_words(text).collect::&lt;Vec&lt;_&gt;&gt;();</span>
<span class="doccomment">/// assert_eq!(lines_to_strings(wrap_first_fit(&amp;words, &amp;[15.0])),</span>
<span class="doccomment">///            vec![&quot;These few words&quot;,</span>
<span class="doccomment">///                 &quot;will&quot;,  // &lt;-- short line</span>
<span class="doccomment">///                 &quot;unfortunately&quot;,</span>
<span class="doccomment">///                 &quot;not wrap&quot;,</span>
<span class="doccomment">///                 &quot;nicely.&quot;]);</span>
<span class="doccomment">///</span>
<span class="doccomment">/// // We can avoid the short line if we look ahead:</span>
<span class="doccomment">/// #[cfg(feature = &quot;smawk&quot;)]</span>
<span class="doccomment">/// use textwrap::wrap_algorithms::{wrap_optimal_fit, Penalties};</span>
<span class="doccomment">/// #[cfg(feature = &quot;smawk&quot;)]</span>
<span class="doccomment">/// assert_eq!(lines_to_strings(wrap_optimal_fit(&amp;words, &amp;[15.0], &amp;Penalties::new()).unwrap()),</span>
<span class="doccomment">///            vec![&quot;These few&quot;,</span>
<span class="doccomment">///                 &quot;words will&quot;,</span>
<span class="doccomment">///                 &quot;unfortunately&quot;,</span>
<span class="doccomment">///                 &quot;not wrap&quot;,</span>
<span class="doccomment">///                 &quot;nicely.&quot;]);</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The [`wrap_optimal_fit`] function was used above to get better</span>
<span class="doccomment">/// line breaks. It uses an advanced algorithm which tries to avoid</span>
<span class="doccomment">/// short lines. This function is about 4 times faster than</span>
<span class="doccomment">/// [`wrap_optimal_fit`].</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Examples</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Imagine you&#39;re building a house site and you have a number of</span>
<span class="doccomment">/// tasks you need to execute. Things like pour foundation, complete</span>
<span class="doccomment">/// framing, install plumbing, electric cabling, install insulation.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The construction workers can only work during daytime, so they</span>
<span class="doccomment">/// need to pack up everything at night. Because they need to secure</span>
<span class="doccomment">/// their tools and move machines back to the garage, this process</span>
<span class="doccomment">/// takes much more time than the time it would take them to simply</span>
<span class="doccomment">/// switch to another task.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// You would like to make a list of tasks to execute every day based</span>
<span class="doccomment">/// on your estimates. You can model this with a program like this:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use textwrap::core::{Fragment, Word};</span>
<span class="doccomment">/// use textwrap::wrap_algorithms::wrap_first_fit;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// #[derive(Debug)]</span>
<span class="doccomment">/// struct Task&lt;&#39;a&gt; {</span>
<span class="doccomment">///     name: &amp;&#39;a str,</span>
<span class="doccomment">///     hours: f64,   // Time needed to complete task.</span>
<span class="doccomment">///     sweep: f64,   // Time needed for a quick sweep after task during the day.</span>
<span class="doccomment">///     cleanup: f64, // Time needed for full cleanup if day ends with this task.</span>
<span class="doccomment">/// }</span>
<span class="doccomment">///</span>
<span class="doccomment">/// impl Fragment for Task&lt;&#39;_&gt; {</span>
<span class="doccomment">///     fn width(&amp;self) -&gt; f64 { self.hours }</span>
<span class="doccomment">///     fn whitespace_width(&amp;self) -&gt; f64 { self.sweep }</span>
<span class="doccomment">///     fn penalty_width(&amp;self) -&gt; f64 { self.cleanup }</span>
<span class="doccomment">/// }</span>
<span class="doccomment">///</span>
<span class="doccomment">/// // The morning tasks</span>
<span class="doccomment">/// let tasks = vec![</span>
<span class="doccomment">///     Task { name: &quot;Foundation&quot;,  hours: 4.0, sweep: 2.0, cleanup: 3.0 },</span>
<span class="doccomment">///     Task { name: &quot;Framing&quot;,     hours: 3.0, sweep: 1.0, cleanup: 2.0 },</span>
<span class="doccomment">///     Task { name: &quot;Plumbing&quot;,    hours: 2.0, sweep: 2.0, cleanup: 2.0 },</span>
<span class="doccomment">///     Task { name: &quot;Electrical&quot;,  hours: 2.0, sweep: 1.0, cleanup: 2.0 },</span>
<span class="doccomment">///     Task { name: &quot;Insulation&quot;,  hours: 2.0, sweep: 1.0, cleanup: 2.0 },</span>
<span class="doccomment">///     Task { name: &quot;Drywall&quot;,     hours: 3.0, sweep: 1.0, cleanup: 2.0 },</span>
<span class="doccomment">///     Task { name: &quot;Floors&quot;,      hours: 3.0, sweep: 1.0, cleanup: 2.0 },</span>
<span class="doccomment">///     Task { name: &quot;Countertops&quot;, hours: 1.0, sweep: 1.0, cleanup: 2.0 },</span>
<span class="doccomment">///     Task { name: &quot;Bathrooms&quot;,   hours: 2.0, sweep: 1.0, cleanup: 2.0 },</span>
<span class="doccomment">/// ];</span>
<span class="doccomment">///</span>
<span class="doccomment">/// // Fill tasks into days, taking `day_length` into account. The</span>
<span class="doccomment">/// // output shows the hours worked per day along with the names of</span>
<span class="doccomment">/// // the tasks for that day.</span>
<span class="doccomment">/// fn assign_days&lt;&#39;a&gt;(tasks: &amp;[Task&lt;&#39;a&gt;], day_length: f64) -&gt; Vec&lt;(f64, Vec&lt;&amp;&#39;a str&gt;)&gt; {</span>
<span class="doccomment">///     let mut days = Vec::new();</span>
<span class="doccomment">///     // Assign tasks to days. The assignment is a vector of slices,</span>
<span class="doccomment">///     // with a slice per day.</span>
<span class="doccomment">///     let assigned_days: Vec&lt;&amp;[Task&lt;&#39;a&gt;]&gt; = wrap_first_fit(&amp;tasks, &amp;[day_length]);</span>
<span class="doccomment">///     for day in assigned_days.iter() {</span>
<span class="doccomment">///         let last = day.last().unwrap();</span>
<span class="doccomment">///         let work_hours: f64 = day.iter().map(|t| t.hours + t.sweep).sum();</span>
<span class="doccomment">///         let names = day.iter().map(|t| t.name).collect::&lt;Vec&lt;_&gt;&gt;();</span>
<span class="doccomment">///         days.push((work_hours - last.sweep + last.cleanup, names));</span>
<span class="doccomment">///     }</span>
<span class="doccomment">///     days</span>
<span class="doccomment">/// }</span>
<span class="doccomment">///</span>
<span class="doccomment">/// // With a single crew working 8 hours a day:</span>
<span class="doccomment">/// assert_eq!(</span>
<span class="doccomment">///     assign_days(&amp;tasks, 8.0),</span>
<span class="doccomment">///     [</span>
<span class="doccomment">///         (7.0, vec![&quot;Foundation&quot;]),</span>
<span class="doccomment">///         (8.0, vec![&quot;Framing&quot;, &quot;Plumbing&quot;]),</span>
<span class="doccomment">///         (7.0, vec![&quot;Electrical&quot;, &quot;Insulation&quot;]),</span>
<span class="doccomment">///         (5.0, vec![&quot;Drywall&quot;]),</span>
<span class="doccomment">///         (7.0, vec![&quot;Floors&quot;, &quot;Countertops&quot;]),</span>
<span class="doccomment">///         (4.0, vec![&quot;Bathrooms&quot;]),</span>
<span class="doccomment">///     ]</span>
<span class="doccomment">/// );</span>
<span class="doccomment">///</span>
<span class="doccomment">/// // With two crews working in shifts, 16 hours a day:</span>
<span class="doccomment">/// assert_eq!(</span>
<span class="doccomment">///     assign_days(&amp;tasks, 16.0),</span>
<span class="doccomment">///     [</span>
<span class="doccomment">///         (14.0, vec![&quot;Foundation&quot;, &quot;Framing&quot;, &quot;Plumbing&quot;]),</span>
<span class="doccomment">///         (15.0, vec![&quot;Electrical&quot;, &quot;Insulation&quot;, &quot;Drywall&quot;, &quot;Floors&quot;]),</span>
<span class="doccomment">///         (6.0, vec![&quot;Countertops&quot;, &quot;Bathrooms&quot;]),</span>
<span class="doccomment">///     ]</span>
<span class="doccomment">/// );</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Apologies to anyone who actually knows how to build a house and</span>
<span class="doccomment">/// knows how long each step takes :-)</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">wrap_first_fit</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="lifetime">&#39;b</span>, <span class="ident">T</span>: <span class="ident">Fragment</span><span class="op">&gt;</span>(
    <span class="ident">fragments</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> [<span class="ident">T</span>],
    <span class="ident">line_widths</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;b</span> [<span class="ident">f64</span>],
) -&gt; <span class="ident">Vec</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> [<span class="ident">T</span>]<span class="op">&gt;</span> {
    <span class="comment">// The final line width is used for all remaining lines.</span>
    <span class="kw">let</span> <span class="ident">default_line_width</span> <span class="op">=</span> <span class="ident">line_widths</span>.<span class="ident">last</span>().<span class="ident">copied</span>().<span class="ident">unwrap_or</span>(<span class="number">0.0</span>);
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">lines</span> <span class="op">=</span> <span class="ident">Vec::new</span>();
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">start</span> <span class="op">=</span> <span class="number">0</span>;
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">width</span> <span class="op">=</span> <span class="number">0.0</span>;

    <span class="kw">for</span> (<span class="ident">idx</span>, <span class="ident">fragment</span>) <span class="kw">in</span> <span class="ident">fragments</span>.<span class="ident">iter</span>().<span class="ident">enumerate</span>() {
        <span class="kw">let</span> <span class="ident">line_width</span> <span class="op">=</span> <span class="ident">line_widths</span>
            .<span class="ident">get</span>(<span class="ident">lines</span>.<span class="ident">len</span>())
            .<span class="ident">copied</span>()
            .<span class="ident">unwrap_or</span>(<span class="ident">default_line_width</span>);
        <span class="kw">if</span> <span class="ident">width</span> <span class="op">+</span> <span class="ident">fragment</span>.<span class="ident">width</span>() <span class="op">+</span> <span class="ident">fragment</span>.<span class="ident">penalty_width</span>() <span class="op">&gt;</span> <span class="ident">line_width</span> <span class="op">&amp;&amp;</span> <span class="ident">idx</span> <span class="op">&gt;</span> <span class="ident">start</span> {
            <span class="ident">lines</span>.<span class="ident">push</span>(<span class="kw-2">&amp;</span><span class="ident">fragments</span>[<span class="ident">start</span>..<span class="ident">idx</span>]);
            <span class="ident">start</span> <span class="op">=</span> <span class="ident">idx</span>;
            <span class="ident">width</span> <span class="op">=</span> <span class="number">0.0</span>;
        }
        <span class="ident">width</span> <span class="op">+</span><span class="op">=</span> <span class="ident">fragment</span>.<span class="ident">width</span>() <span class="op">+</span> <span class="ident">fragment</span>.<span class="ident">whitespace_width</span>();
    }
    <span class="ident">lines</span>.<span class="ident">push</span>(<span class="kw-2">&amp;</span><span class="ident">fragments</span>[<span class="ident">start</span>..]);
    <span class="ident">lines</span>
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">tests</span> {
    <span class="kw">use</span> <span class="kw">super</span>::<span class="kw-2">*</span>;

    <span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">PartialEq</span>)]</span>
    <span class="kw">struct</span> <span class="ident">Word</span>(<span class="ident">f64</span>);

    <span class="attribute">#[<span class="ident">rustfmt::skip</span>]</span>
    <span class="kw">impl</span> <span class="ident">Fragment</span> <span class="kw">for</span> <span class="ident">Word</span> {
        <span class="kw">fn</span> <span class="ident">width</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">f64</span> { <span class="self">self</span>.<span class="number">0</span> }
        <span class="kw">fn</span> <span class="ident">whitespace_width</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">f64</span> { <span class="number">1.0</span> }
        <span class="kw">fn</span> <span class="ident">penalty_width</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">f64</span> { <span class="number">0.0</span> }
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">wrap_string_longer_than_f64</span>() {
        <span class="kw">let</span> <span class="ident">words</span> <span class="op">=</span> <span class="macro">vec!</span>[
            <span class="ident">Word</span>(<span class="number">1e307</span>),
            <span class="ident">Word</span>(<span class="number">2e307</span>),
            <span class="ident">Word</span>(<span class="number">3e307</span>),
            <span class="ident">Word</span>(<span class="number">4e307</span>),
            <span class="ident">Word</span>(<span class="number">5e307</span>),
            <span class="ident">Word</span>(<span class="number">6e307</span>),
        ];
        <span class="comment">// Wrap at just under f64::MAX (~19e307). The tiny</span>
        <span class="comment">// whitespace_widths disappear because of loss of precision.</span>
        <span class="macro">assert_eq!</span>(
            <span class="ident">wrap_first_fit</span>(<span class="kw-2">&amp;</span><span class="ident">words</span>, <span class="kw-2">&amp;</span>[<span class="number">15e307</span>]),
            <span class="kw-2">&amp;</span>[
                <span class="macro">vec!</span>[
                    <span class="ident">Word</span>(<span class="number">1e307</span>),
                    <span class="ident">Word</span>(<span class="number">2e307</span>),
                    <span class="ident">Word</span>(<span class="number">3e307</span>),
                    <span class="ident">Word</span>(<span class="number">4e307</span>),
                    <span class="ident">Word</span>(<span class="number">5e307</span>)
                ],
                <span class="macro">vec!</span>[<span class="ident">Word</span>(<span class="number">6e307</span>)]
            ]
        );
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="textwrap" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>